
%global meadversion 23.1.2.0_3
%global namedversion 23.1.2.0-3-redhat-00001
%global meadalpha .redhat_00001
%global meadrel .1
%global serial 1
%global namedversionrel redhat-00001

# Template marker
%bcond_without mead

# Mandrel is sensitive to internal changes of the JDK so we need to make sure
# Mandrel is compatible with the installed JDK, thus we require a specific
# jdk version to be installed.
%global jdkversion %(rpm -q --qf '%%{VERSION}-%%{RELEASE}' java-21-openjdk || : )
%global jdkepoch %(rpm -q --qf '%%{EPOCH}:' java-21-openjdk || : )
# Please don't add architecture specific bits to this global. See the post
# script where this is being used.
%global jdkdir %{_jvmdir}/java-21-openjdk-%{jdkversion}

%define maven_version 23.1.2.0-3-redhat-00001

Name:    quarkus-mandrel-java
Summary: Mandrel jars
Version: %{meadversion}
Release: %{serial}%{meadalpha}%{meadrel}%{?dist}
License: GPLv2 with exceptions
Group:   Development/Java

%if %with mead
Source102: svm-23.1.2.0-3-redhat-00001.pom
Source103: svm-agent-23.1.2.0-3-redhat-00001-sources.jar
Source104: svm-configure-23.1.2.0-3-redhat-00001.pom
Source105: svm-diagnostics-agent-23.1.2.0-3-redhat-00001-sources.jar
Source106: jvmti-agent-base-23.1.2.0-3-redhat-00001.pom
Source107: polyglot-23.1.2.0-3-redhat-00001.jar
Source108: svm-agent-23.1.2.0-3-redhat-00001.pom
Source109: collections-23.1.2.0-3-redhat-00001.pom
Source110: svm-driver-23.1.2.0-3-redhat-00001-sources.jar
Source111: truffle-compiler-23.1.2.0-3-redhat-00001.jar
Source112: truffle-compiler-23.1.2.0-3-redhat-00001-sources.jar
Source113: collections-23.1.2.0-3-redhat-00001-sources.jar
Source114: svm-foreign-23.1.2.0-3-redhat-00001.pom
Source115: svm-foreign-23.1.2.0-3-redhat-00001-sources.jar
Source116: jvmti-agent-base-23.1.2.0-3-redhat-00001-sources.jar
Source117: compiler-23.1.2.0-3-redhat-00001-sources.jar
Source118: compiler-23.1.2.0-3-redhat-00001.pom
Source119: polyglot-23.1.2.0-3-redhat-00001.pom
Source120: native-image-base-23.1.2.0-3-redhat-00001.jar
Source121: compiler-23.1.2.0-3-redhat-00001.jar
Source122: word-23.1.2.0-3-redhat-00001-sources.jar
Source123: svm-diagnostics-agent-23.1.2.0-3-redhat-00001.jar
Source124: pointsto-23.1.2.0-3-redhat-00001.jar
Source125: svm-diagnostics-agent-23.1.2.0-3-redhat-00001.pom
Source126: word-23.1.2.0-3-redhat-00001.pom
Source127: svm-agent-23.1.2.0-3-redhat-00001.jar
Source128: word-23.1.2.0-3-redhat-00001.jar
Source129: mandrel-packaging-wrapper-linux-amd64-23.1.2.0-3-redhat-00001.pom
Source130: svm-driver-23.1.2.0-3-redhat-00001.jar
Source131: svm-23.1.2.0-3-redhat-00001-sources.jar
Source132: library-support-23.1.2.0-3-redhat-00001.pom
Source133: svm-foreign-23.1.2.0-3-redhat-00001.jar
Source134: polyglot-23.1.2.0-3-redhat-00001-sources.jar
Source135: svm-23.1.2.0-3-redhat-00001.jar
Source136: library-support-23.1.2.0-3-redhat-00001-sources.jar
Source137: mandrel-packaging-wrapper-linux-amd64-23.1.2.0-3-redhat-00001.jar
Source138: nativeimage-23.1.2.0-3-redhat-00001.pom
Source139: svm-driver-23.1.2.0-3-redhat-00001.pom
Source140: svm-configure-23.1.2.0-3-redhat-00001-sources.jar
Source141: jvmti-agent-base-23.1.2.0-3-redhat-00001.jar
Source142: nativeimage-23.1.2.0-3-redhat-00001-sources.jar
Source143: graal-sdk-23.1.2.0-3-redhat-00001.jar
Source144: objectfile-23.1.2.0-3-redhat-00001.pom
Source145: native-image-base-23.1.2.0-3-redhat-00001.pom
Source146: library-support-23.1.2.0-3-redhat-00001.jar
Source147: nativeimage-23.1.2.0-3-redhat-00001.jar
Source148: truffle-compiler-23.1.2.0-3-redhat-00001.pom
Source149: graal-sdk-23.1.2.0-3-redhat-00001.pom
Source150: pointsto-23.1.2.0-3-redhat-00001.pom
Source151: graal-sdk-23.1.2.0-3-redhat-00001-sources.jar
Source152: pointsto-23.1.2.0-3-redhat-00001-sources.jar
Source153: native-image-base-23.1.2.0-3-redhat-00001-sources.jar
Source154: svm-configure-23.1.2.0-3-redhat-00001.jar
Source155: collections-23.1.2.0-3-redhat-00001.jar
Source156: objectfile-23.1.2.0-3-redhat-00001.jar
Source157: objectfile-23.1.2.0-3-redhat-00001-sources.jar
Source158: mandrel-java-all-23.1.2.0-3-redhat-00001-project-sources.tar.gz
%endif


URL:     https://github.com/graalvm/mandrel

BuildArch: noarch
BuildRequires: javapackages-filesystem
BuildRequires: java-21-openjdk-devel

%description
%{summary}.

%package jdk-21-binding
Summary: Mandrel jars for JDK 21 based build
Requires: java-21-openjdk-devel = %{jdkepoch}%{jdkversion}
Requires: %{name} = %{version}

%description jdk-21-binding
%{summary}.

%prep
if [ -z "%jdkversion" ]
then
    echo "rpm failed to obtain java-21-openjdk version, check BuildRequires"
    exit 11
fi

%build

%install
cd %{_sourcedir}
# jars
%{__mkdir_p} %{buildroot}%{_javadir}/%{name}

for jar in *-%{namedversion}*.jar; do %{__cp} -p ${jar} %{buildroot}%{_javadir}/%{name}/${jar/-%{namedversion}/}; done

# symlinks from foo.src.zip to foo-sources.jar
%{__ln_s} %{_javadir}/%{name}/library-support-sources.jar %{buildroot}%{_javadir}/%{name}/library-support.src.zip
%{__ln_s} %{_javadir}/%{name}/svm-sources.jar %{buildroot}%{_javadir}/%{name}/svm.src.zip
%{__ln_s} %{_javadir}/%{name}/svm-foreign-sources.jar %{buildroot}%{_javadir}/%{name}/svm-foreign.src.zip
%{__ln_s} %{_javadir}/%{name}/pointsto-sources.jar %{buildroot}%{_javadir}/%{name}/pointsto.src.zip
%{__ln_s} %{_javadir}/%{name}/objectfile-sources.jar %{buildroot}%{_javadir}/%{name}/objectfile.src.zip
%{__ln_s} %{_javadir}/%{name}/native-image-base-sources.jar %{buildroot}%{_javadir}/%{name}/native-image-base.src.zip
%{__ln_s} %{_javadir}/%{name}/svm-driver-sources.jar %{buildroot}%{_javadir}/%{name}/svm-driver.src.zip
%{__ln_s} %{_javadir}/%{name}/jvmti-agent-base-sources.jar %{buildroot}%{_javadir}/%{name}/jvmti-agent-base.src.zip
%{__ln_s} %{_javadir}/%{name}/svm-agent-sources.jar %{buildroot}%{_javadir}/%{name}/svm-agent.src.zip
%{__ln_s} %{_javadir}/%{name}/svm-diagnostics-agent-sources.jar %{buildroot}%{_javadir}/%{name}/svm-diagnostics-agent.src.zip
%{__ln_s} %{_javadir}/%{name}/svm-configure-sources.jar %{buildroot}%{_javadir}/%{name}/svm-configure.src.zip
%{__ln_s} %{_javadir}/%{name}/graal-sdk-sources.jar %{buildroot}%{_javadir}/%{name}/graal-sdk.src.zip
%{__ln_s} %{_javadir}/%{name}/word-sources.jar %{buildroot}%{_javadir}/%{name}/word.src.zip
%{__ln_s} %{_javadir}/%{name}/collections-sources.jar %{buildroot}%{_javadir}/%{name}/collections.src.zip
%{__ln_s} %{_javadir}/%{name}/nativeimage-sources.jar %{buildroot}%{_javadir}/%{name}/nativeimage.src.zip
%{__ln_s} %{_javadir}/%{name}/truffle-compiler-sources.jar %{buildroot}%{_javadir}/%{name}/truffle-compiler.src.zip
%{__ln_s} %{_javadir}/%{name}/compiler-sources.jar %{buildroot}%{_javadir}/%{name}/graal.src.zip

%files
%defattr(0644,root,root,0755)
%{_javadir}/%{name}/svm.jar
%{_javadir}/%{name}/svm-sources.jar
%{_javadir}/%{name}/svm.src.zip
%{_javadir}/%{name}/svm-foreign.jar
%{_javadir}/%{name}/svm-foreign-sources.jar
%{_javadir}/%{name}/svm-foreign.src.zip
%{_javadir}/%{name}/pointsto.jar
%{_javadir}/%{name}/pointsto-sources.jar
%{_javadir}/%{name}/pointsto.src.zip
%{_javadir}/%{name}/objectfile.jar
%{_javadir}/%{name}/objectfile-sources.jar
%{_javadir}/%{name}/objectfile.src.zip
%{_javadir}/%{name}/native-image-base.jar
%{_javadir}/%{name}/native-image-base-sources.jar
%{_javadir}/%{name}/native-image-base.src.zip
%{_javadir}/%{name}/svm-driver.jar
%{_javadir}/%{name}/svm-driver-sources.jar
%{_javadir}/%{name}/svm-driver.src.zip
%{_javadir}/%{name}/graal-sdk.jar
%{_javadir}/%{name}/graal-sdk-sources.jar
%{_javadir}/%{name}/graal-sdk.src.zip
%{_javadir}/%{name}/word.jar
%{_javadir}/%{name}/word-sources.jar
%{_javadir}/%{name}/word.src.zip
%{_javadir}/%{name}/collections.jar
%{_javadir}/%{name}/collections-sources.jar
%{_javadir}/%{name}/collections.src.zip
%{_javadir}/%{name}/nativeimage.jar
%{_javadir}/%{name}/nativeimage-sources.jar
%{_javadir}/%{name}/nativeimage.src.zip
%{_javadir}/%{name}/polyglot.jar
%{_javadir}/%{name}/polyglot-sources.jar
%{_javadir}/%{name}/truffle-compiler.jar
%{_javadir}/%{name}/truffle-compiler-sources.jar
%{_javadir}/%{name}/truffle-compiler.src.zip
%{_javadir}/%{name}/compiler.jar
%{_javadir}/%{name}/compiler-sources.jar
%{_javadir}/%{name}/graal.src.zip
%{_javadir}/%{name}/library-support.jar
%{_javadir}/%{name}/library-support-sources.jar
%{_javadir}/%{name}/library-support.src.zip
%{_javadir}/%{name}/jvmti-agent-base.jar
%{_javadir}/%{name}/jvmti-agent-base-sources.jar
%{_javadir}/%{name}/jvmti-agent-base.src.zip
%{_javadir}/%{name}/svm-agent.jar
%{_javadir}/%{name}/svm-agent-sources.jar
%{_javadir}/%{name}/svm-agent.src.zip
%{_javadir}/%{name}/svm-diagnostics-agent.jar
%{_javadir}/%{name}/svm-diagnostics-agent-sources.jar
%{_javadir}/%{name}/svm-diagnostics-agent.src.zip
%{_javadir}/%{name}/svm-configure.jar
%{_javadir}/%{name}/svm-configure-sources.jar
%{_javadir}/%{name}/svm-configure.src.zip
%{_javadir}/%{name}/mandrel-packaging-wrapper-linux-amd64.jar

%files jdk-21-binding
# No files, just for pulling in the version-specific JDK

%post
# Add symlinks in OpenJDK. This must not use macros which
# contain arch-full paths. Macros get expanded at build time
# and this is a noarch package, while the JDK install includes
# the achitecture in the path. The trick here is to use 'uname -m'
# for the architecture bits which is correct since the script
# runs on the target arch at install time and not at build time.
JDK_DIR="%{jdkdir}.$(uname -m)"
%{__mkdir_p} ${JDK_DIR}/lib/svm
%{__ln_s} %{_javadir}/%{name}/library-support.jar ${JDK_DIR}/lib/svm/
%{__ln_s} %{_javadir}/%{name}/library-support.src.zip ${JDK_DIR}/lib/svm/

%{__mkdir_p} ${JDK_DIR}/lib/svm-preview/builder
%{__ln_s} %{_javadir}/%{name}/svm-foreign.jar ${JDK_DIR}/lib/svm-preview/builder/
%{__ln_s} %{_javadir}/%{name}/svm-foreign.src.zip ${JDK_DIR}/lib/svm-preview/builder/

%{__mkdir_p} ${JDK_DIR}/lib/svm/builder
%{__ln_s} %{_javadir}/%{name}/svm.jar ${JDK_DIR}/lib/svm/builder/
%{__ln_s} %{_javadir}/%{name}/svm.src.zip ${JDK_DIR}/lib/svm/builder/
%{__ln_s} %{_javadir}/%{name}/pointsto.jar ${JDK_DIR}/lib/svm/builder/
%{__ln_s} %{_javadir}/%{name}/pointsto.src.zip ${JDK_DIR}/lib/svm/builder/
%{__ln_s} %{_javadir}/%{name}/objectfile.jar ${JDK_DIR}/lib/svm/builder/
%{__ln_s} %{_javadir}/%{name}/objectfile.src.zip ${JDK_DIR}/lib/svm/builder/
%{__ln_s} %{_javadir}/%{name}/native-image-base.jar ${JDK_DIR}/lib/svm/builder/
%{__ln_s} %{_javadir}/%{name}/native-image-base.src.zip ${JDK_DIR}/lib/svm/builder/

%{__mkdir_p} ${JDK_DIR}/lib/graalvm
%{__ln_s} %{_javadir}/%{name}/svm-driver.jar ${JDK_DIR}/lib/graalvm
%{__ln_s} %{_javadir}/%{name}/svm-driver.src.zip ${JDK_DIR}/lib/graalvm
%{__ln_s} %{_javadir}/%{name}/jvmti-agent-base.jar ${JDK_DIR}/lib/graalvm
%{__ln_s} %{_javadir}/%{name}/jvmti-agent-base.src.zip ${JDK_DIR}/lib/graalvm
%{__ln_s} %{_javadir}/%{name}/svm-agent.jar ${JDK_DIR}/lib/graalvm
%{__ln_s} %{_javadir}/%{name}/svm-agent.src.zip ${JDK_DIR}/lib/graalvm
%{__ln_s} %{_javadir}/%{name}/svm-diagnostics-agent.jar ${JDK_DIR}/lib/graalvm
%{__ln_s} %{_javadir}/%{name}/svm-diagnostics-agent.src.zip ${JDK_DIR}/lib/graalvm
%{__ln_s} %{_javadir}/%{name}/svm-configure.jar ${JDK_DIR}/lib/graalvm
%{__ln_s} %{_javadir}/%{name}/svm-configure.src.zip ${JDK_DIR}/lib/graalvm

%{__mkdir_p} ${JDK_DIR}/lib/jvmci
# This is only a placeholder since 23.1 after the graal-sdk
# maven artefact split
%{__ln_s} %{_javadir}/%{name}/graal-sdk.jar ${JDK_DIR}/lib/jvmci
%{__ln_s} %{_javadir}/%{name}/graal-sdk.src.zip ${JDK_DIR}/lib/jvmci
%{__ln_s} %{_javadir}/%{name}/collections.jar ${JDK_DIR}/lib/jvmci
%{__ln_s} %{_javadir}/%{name}/collections.src.zip ${JDK_DIR}/lib/jvmci
%{__ln_s} %{_javadir}/%{name}/word.jar ${JDK_DIR}/lib/jvmci
%{__ln_s} %{_javadir}/%{name}/word.src.zip ${JDK_DIR}/lib/jvmci
%{__ln_s} %{_javadir}/%{name}/nativeimage.jar ${JDK_DIR}/lib/jvmci
%{__ln_s} %{_javadir}/%{name}/nativeimage.src.zip ${JDK_DIR}/lib/jvmci
# graal compiler
%{__ln_s} %{_javadir}/%{name}/compiler.jar ${JDK_DIR}/lib/jvmci/graal.jar
%{__ln_s} %{_javadir}/%{name}/graal.src.zip ${JDK_DIR}/lib/jvmci/

# truffle compiler
%{__mkdir_p} ${JDK_DIR}/lib/truffle
%{__ln_s} %{_javadir}/%{name}/truffle-compiler.jar ${JDK_DIR}/lib/truffle
%{__ln_s} %{_javadir}/%{name}/truffle-compiler.src.zip ${JDK_DIR}/lib/truffle

%postun
# Remove mandrel symlinks in OpenJDK install location
JDK_DIR="%{jdkdir}.$(uname -m)"
if [ -e "${JDK_DIR}/lib/svm" ]; then
%{__rm} -rf ${JDK_DIR}/lib/svm
fi
if [ -e "${JDK_DIR}/lib/jvmci" ]; then
%{__rm} -rf ${JDK_DIR}/lib/jvmci
fi
if [ -e "${JDK_DIR}/lib/graalvm" ]; then
%{__rm} -rf ${JDK_DIR}/lib/graalvm
fi
if [ -e "${JDK_DIR}/lib/truffle" ]; then
%{__rm} -rf ${JDK_DIR}/lib/truffle
fi


%changelog
* Thu Mar 21 2024 cpaas-ops <cpaas-ops@redhat.com> - 23.1.2.0_3-1.redhat_00001.1
- Built by CPaaS

Signed-off-by: sgehwolf <sgehwolf@redhat.com>


* Thu Mar 07 2024 cpaas-ops <cpaas-ops@redhat.com> - 23.1.2.0_2-5.redhat_00001.1
- Built by CPaaS

Signed-off-by: sgehwolf <sgehwolf@redhat.com>


* Wed Mar 06 2024 cpaas-ops <cpaas-ops@redhat.com> - 23.1.2.0_2-4.redhat_00001.1
- Built by CPaaS

Signed-off-by: sgehwolf <sgehwolf@redhat.com>


* Mon Feb 26 2024 cpaas-ops <cpaas-ops@redhat.com> - 23.1.2.0_2-3.redhat_00001.1
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Tue Feb 13 2024 cpaas-ops <cpaas-ops@redhat.com> - 23.1.2.0_2-2.redhat_00001.1
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Tue Feb 13 2024 cpaas-ops <cpaas-ops@redhat.com> - 23.1.2.0_2-1.redhat_00001.1
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Mon Feb 12 2024 Severin Gehwolf <sgehwolf@redhat.com> - 23.2.1.0-1
- Initial wrapper RPM package for Mandrel 23.1
